unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ExtDlgs, StdCtrls, XPMan;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    Button2: TButton;
    Image1: TImage;
    XPManifest1: TXPManifest;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  bmp: TBitmap;
  ico: TIcon;

implementation

{$R *.dfm}

procedure CreateIcon;
var
  cinfo: TIconInfo;
  x,y: integer;
  src: pByteArray;
  r,g,b: byte;
begin
  if bmp.PixelFormat<>pf32bit then begin
    bmp.PixelFormat:=pf32bit;
    src:=bmp.ScanLine[bmp.Height-1];
    r:=src[2]; g:=src[1]; b:=src[0];
    for y:=0 to bmp.Height-1 do begin
      src:=bmp.ScanLine[y];
      for x:=0 to bmp.Width-1 do begin
        if (r=src[x*4+2]) and (g=src[x*4+1]) and (b=src[x*4+0])
        then src[x*4+3]:=0 else src[x*4+3]:=255;
      end;
    end;
  end;

  cinfo.fIcon:=true;
  cinfo.xHotspot:=0;
  cinfo.yHotspot:=0;
  cinfo.hbmMask:=bmp.Handle;
  cinfo.hbmColor:=bmp.Handle;
  ico.Handle:=CreateIconIndirect(cinfo);
end;

procedure SaveIcon(fname: string);
type
  TIconRec = packed record
    Width: byte;
    Height: byte;
    Colors: byte;
    Reserved: byte;
    Planes: word;
    BPP: word;
    DIBSize: dword;
    DIBOffset: dword;
  end;
  TCursorOrIcon = packed record
    Reserved: word;
    wType: word;
    Count: word;
  end;
var
  i: integer;
  ico: file of byte;
  hdr: TCursorOrIcon;
  irec: TIconRec;
  binfo: TBitmapInfoHeader;
  mask: TBitmap;
begin
  hdr.Reserved:=0;
  hdr.wType:=1;
  hdr.Count:=1;
  AssignFile(ico, fname);
  Rewrite(ico);
  BlockWrite(ico, hdr, SizeOf(hdr));

  if bmp.Width<256 then irec.Width:=bmp.Width else irec.Width:=0;
  if bmp.Height<256 then irec.Height:=bmp.Height else irec.Height:=0;
  irec.Colors:=0;
  irec.Reserved:=0;
  irec.Planes:=0;
  irec.BPP:=32;
  irec.DIBSize:=(bmp.Width*bmp.Height*4)+(bmp.Width*bmp.Height div 8);
  irec.DIBOffset:=SizeOf(hdr)+SizeOf(irec);
  BlockWrite(ico, irec, SizeOf(irec));

  binfo.biSize:=SizeOf(binfo);
  binfo.biWidth:=bmp.Width;
  binfo.biHeight:=bmp.Height*2;
  binfo.biPlanes:=1;
  binfo.biBitCount:=32;
  binfo.biCompression:=BI_RGB;
  binfo.biSizeImage:=bmp.Width*bmp.Height*4;
  binfo.biXPelsPerMeter:=0;
  binfo.biYPelsPerMeter:=0;
  binfo.biClrUsed:=0;
  binfo.biClrImportant:=0;
  BlockWrite(ico, binfo, SizeOf(binfo));
  for i:=bmp.Height-1 downto 0 do BlockWrite(ico, bmp.ScanLine[i]^, bmp.Width*4);

  mask:=TBitmap.Create;
  mask.Monochrome:=true;
  mask.Height:=bmp.Height;
  mask.Width:=bmp.Width;
  mask.Canvas.Brush.Color:=clBlack;
  mask.Canvas.FillRect(mask.Canvas.ClipRect);
  for i:=mask.Height-1 downto 0 do BlockWrite(ico, mask.ScanLine[i]^, mask.Width div 8);
  mask.Destroy;

  CloseFile(ico);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then begin
    bmp.LoadFromFile(OpenPictureDialog1.FileName);
    CreateIcon;
    image1.Picture.Assign(ico);
    Screen.Cursors[1]:=ico.Handle;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if SavePictureDialog1.Execute then SaveIcon(SavePictureDialog1.FileName);
  //if SavePictureDialog1.Execute then ico.SaveToFile(SavePictureDialog1.FileName);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  bmp:=TBitmap.Create;
  ico:=TIcon.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  bmp.Destroy;
  ico.Destroy;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Screen.Cursor:=1;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Screen.Cursor:=crDefault;
end;

end.
